﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Text;

namespace BEncoding
{
    class BEncoding
    {

        private BEncoding()
        {
        }

        public static object Decode(string s)
        {
            return DecodeObject(s, ref _index, EncodeState.Value);
        }

        private enum EncodeState
        {
            Key,
            Value
        }

        private static int _index;

        private static object DecodeObject(string str,ref int index, EncodeState state)
        {
            var obj = new Dictionary<string, object>();

            var c = str[index];
            while (c != 'e')
            {
                if (c == 'd')//字典类型
                {
                    index++;
                    return DecodeObject(str, ref index,EncodeState.Key);
                }
                if (c == 'i')//数字类型
                {
                    string value = "";
                    index++; c = str[index];
                    while (c != 'e')
                    {
                        value += c.ToString(CultureInfo.InvariantCulture);
                        index++;
                        c = str[index];
                    }
                    return Convert.ToInt32(value);
                }
                if (c == 'l')//列表类型
                {
                    index++;
                    var value = new List<object>();
                    while (str[index]!='e')
                    {
                        value.Add(DecodeObject(str, ref index, EncodeState.Value));
                        index++;
                    }
                    return value;
                }
                if ('0' < c && c <= '9') //字符串类型
                {
                    string strLength = "";
                    while (c != ':')
                    {
                        strLength += c.ToString(CultureInfo.InvariantCulture);
                        c = str[++index];
                    }
                    var length = Convert.ToInt32(strLength);
                    var strContent = "";
                    for (int i = 0; i < length; i++)
                    {
                        strContent += str[index + 1].ToString(CultureInfo.InvariantCulture);
                        index++;
                    }
                    if (state == EncodeState.Value)
                    {
                        return strContent;
                    }
                    index++;
                    obj.Add(strContent, DecodeObject(str, ref index, EncodeState.Value));
                    state = EncodeState.Key;
                    index++;
                }
                c = str[index];
            }
            return obj;
        }

        public static string Encode(object obj)
        {
            var sb = new StringBuilder();
            if(obj is Dictionary<string,object>)
            {
                var parseObj = obj as Dictionary<string, object>;
                sb.Append("d");
                foreach (var o in parseObj)
                {
                    sb.AppendFormat("{0}:{1}{2}", o.Key.Length,o.Key, Encode(o.Value));
                }
                sb.Append("e");
            }
            if ((obj as int?) != null)
            {
                var parseObj = (int) obj;
                sb.AppendFormat("i{0}e", parseObj);
            }
            if (obj is List<object>)
            {
                var parseObj = obj as List<object>;
                sb.Append("l");
                foreach (var o in parseObj)
                {
                    sb.Append(Encode(o));
                }
                sb.Append("e");
            }
            if (obj is string)
            {
                var parseObj = obj as string;
                sb.AppendFormat("{0}:{1}", parseObj.Length, parseObj);
            }
            return sb.ToString();
        }
    }
}